C   14-MAR-90   OCC IS ADDED WHEN SUM OVER NBANDS TO GET CHARGE DENSITY
C               X.WENG (SEARCH FOR 'OCC' TO FINE THE CHANGES)
C
C
C***********************************************************************
C***********************************************************************
      SUBROUTINE CHSP(NBANDS,NPLWV,NRPLWV,
     &    MPLWV,WTKPT,CPTWFP,CHDEN,CHDENR,NGPTAR,NINDPW,
     &    NPLWKP,CPTDUM,CWORK2,OCC)
C=======================================================================
C
C{{{{{{{{{{{{{{{{{{{{{{{{{ SUBROUTINE CHSP }}}}}}}}}}}}}}}}}}}}}}}}}}}}}
C
C SUBROUTINE CHSP CONSTRUCTS THE ELECTRONIC CHARGE DENSITY AND COMPUTES
C THE REAL SPACE WAVEFUNCTIONS WHICH ARE USED AGAIN IN THE ELECTRON
C DYNAMICS SUBROUTINE
C
      IMPLICIT COMPLEX (C)
      DIMENSION CPTWFP(*)
      DIMENSION CHDEN(*)
      DIMENSION CHDENR(*)
      DIMENSION NGPTAR(*)
      DIMENSION NINDPW(*)
      DIMENSION OCC(*)
C=======================================================================
C
C                   THE DIMENSION STATEMENTS
C
C CPTDUM(MPLWV) = THE ARRAY USED TO SUPPLY THE DATA TO THE FAST FOURIER
C                 TRANSFORM SUBROUTINE
C
C=======================================================================
      DIMENSION CPTDUM(*)
      DIMENSION CWORK2(*)
C=======================================================================
C INITIALISE THE CHARGE DENSITY AT THIS K POINT TO ZERO
C=======================================================================
      DO 5505 NP=1,NPLWV
      CHDEN(NP)=(0.0,0.0)
 5505 CONTINUE
      DO 5502 NN=1,NBANDS
C=======================================================================
C INITIALISE THE ARRAYS USED IN THE FOURIER TRANSFORM TO ZERO. THIS STEP
C MUST BE PERFORMED TO ENSURE THAT THE COEFFICIENTS OF THE PLANE WAVES
C BEYOND THE CUT-OFF ENERGY ARE ZERO.
C=======================================================================
      DO 5561 M=1,MPLWV
      CPTDUM(M)=(0.0,0.0)
      CWORK2(M)=(0.0,0.0)
 5561 CONTINUE
      NINDW=NRPLWV*(NN-1)
      DO 5510 M=1,NPLWKP
      CPTDUM(NINDPW(M))=CPTWFP(M+NINDW)
 5510 CONTINUE
C=======================================================================
C TRANSFORM THE WAVEFUNCTION INTO REAL SPACE
C=======================================================================
      CALL FFT3D(CPTDUM,CWORK2,NGPTAR,1)
C=======================================================================
C CALCULATE THE CHARGE DENSITY IN REAL SPACE AND STORE THE REAL SPACE
C WAVEFUNCTION FOR USE IN THE ELECTRON DYNAMICS SUBROUTINE
C=======================================================================
      DO 5540 M=1,NPLWV
      CHDEN(M)=CHDEN(M)+(CPTDUM(M))*CONJG(CPTDUM(M))*OCC(NN)
 5540 CONTINUE
 5502 CONTINUE
C=======================================================================
C ADD CHARGE DENSITY AT THE PRESENT K POINT TO THE TOTAL CHARGE DENSITY
C MULTIPLYING BY 2 FOR SPINS AND BY THE WEIGHTING FACTOR FOR THE K POINT
C=======================================================================
      DO 5506 NP=1,NPLWV
      CHDENR(NP)=CHDENR(NP)+CHDEN(NP)*2.0*WTKPT
 5506 CONTINUE
 5580 CONTINUE
      RETURN
      END
 
